> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/cn/web-scraper-api/mu-biao/dian-zi-shang-wu/ralphs.md).

# Ralphs

了解如何开始抓取 Ralphs。

使用 网页爬虫API，您可以抓取各种类型的 **Ralphs** 页面；下面是所有受支持爬虫及其各自 `source` 值的概览。响应会在 `content`中返回页面 HTML，采用 [Realtime](https://developers.oxylabs.io/products/cn/web-scraper-api/integration-methods/realtime.md) 和 [Push-Pull](https://developers.oxylabs.io/products/cn/web-scraper-api/integration-methods/push-pull.md).

{% hint style="warning" %}
对于某些目标，我们的系统 **强制进行 JavaScript 渲染** 即使您未设置 `render`；这些请求会计为已渲染流量。强制渲染的目标列表以及如何关闭渲染，请见 [对特定页面强制渲染](https://developers.oxylabs.io/products/cn/web-scraper-api/features/js-rendering-and-browser-control.md#forcing-rendering-on-specific-pages).
{% endhint %}

<table><thead><tr><th width="250">Source</th><th>说明</th></tr></thead><tbody><tr><td><code>ralphs_search</code></td><td><a href="#search"><strong>搜索页</strong></a> 用于您选择的搜索词。</td></tr><tr><td><code>ralphs_product</code></td><td><a href="#product"><strong>商品页</strong></a> 用于您选择的商品 ID。</td></tr></tbody></table>

通过传入其，任何其他 Ralphs 页面都可以被抓取 `url` 即可抓取，无需 `source` 其他参数。

{% hint style="info" %}
除了下面列出的参数外，您还可以添加其他参数，例如 `user_agent_type`, `geo_location`, `render`等，以自定义您的抓取请求。更多信息见 [这里](https://developers.oxylabs.io/products/cn/web-scraper-api/features.md).
{% endhint %}

## 搜索

### 请求示例

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "ralphs_search",
        "query": "milk"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'ralphs_search',
    'query': 'milk'
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Instead of response with job status and results url, this will return the
# JSON response with the result.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "ralphs_search",
    query: "milk"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
您提交的整个字符串必须进行 URL 编码。

https://realtime.oxylabs.io/v1/queries?source=ralphs_search&query=milk&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'ralphs_search',
    'query' => 'milk'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "ralphs_search",
        "query": "milk",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "ralphs_search",
                query = "milk"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "ralphs_search");
        jsonObject.put("query", "milk");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "ralphs_search",
    "query": "milk"
}
```

{% endtab %}
{% endtabs %}

### 请求参数值 <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">参数</th><th>说明</th><th width="160">默认值</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>设置抓取器。</td><td><code>ralphs_search</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark></td><td>要搜索商品的关键词或短语。</td><td>-</td></tr><tr><td><code>store_id</code>, <code>delivery_zip</code>, <code>fulfillment_type</code>, <code>price_range</code>, <code>brand</code></td><td>可选的本地化和过滤参数，见 <a href="#localization-and-filtering">本地化和过滤</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- 必填参数

## 商品 <a href="#product" id="product"></a>

### 请求示例

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "ralphs_product",
        "product_id": "0001111016338"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    'source': 'ralphs_product',
    'product_id': '0001111016338'
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload
)

# Instead of response with job status and results url, this will return the
# JSON response with the result.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "ralphs_product",
    product_id: "0001111016338"
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
您提交的整个字符串必须进行 URL 编码。

https://realtime.oxylabs.io/v1/queries?source=ralphs_product&product_id=0001111016338&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'ralphs_product',
    'product_id' => '0001111016338'
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "ralphs_product",
        "product_id": "0001111016338",
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://realtime.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "ralphs_product",
                product_id = "0001111016338"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "ralphs_product");
        jsonObject.put("product_id", "0001111016338");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "ralphs_product",
    "product_id": "0001111016338"
}
```

{% endtab %}
{% endtabs %}

### 请求参数值 <a href="#request-parameter-values" id="request-parameter-values"></a>

<table><thead><tr><th width="180">参数</th><th>说明</th><th width="160">默认值</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>设置抓取器。</td><td><code>ralphs_product</code></td></tr><tr><td><mark style="background-color:green;"><strong><code>product_id</code></strong></mark></td><td>13 位商品 ID，可在商品页 URL 末尾找到，例如 <code>ralphs.com/p/kroger-carbmaster-original-lactose-free-skim-milk/</code><strong><code>0001111016338</code></strong>.</td><td>-</td></tr><tr><td><code>store_id</code>, <code>delivery_zip</code>, <code>fulfillment_type</code></td><td>可选的本地化参数，见 <a href="#localization-and-filtering">本地化和过滤</a>.</td><td>-</td></tr></tbody></table>

&#x20;   \- 必填参数

## 本地化和过滤 <a href="#localization-and-filtering" id="localization-and-filtering"></a>

Ralphs 会显示所选门店或配送区域的搜索结果和商品可用性。如果下面的参数都未设置，网站将回退到其自行选择的门店。

<table><thead><tr><th width="130.3046875">参数</th><th width="93.96875">适用于</th><th width="309.09765625">说明</th><th width="224.91015625">默认值</th></tr></thead><tbody><tr><td><code>store_id</code></td><td><code>ralphs_search</code>, <code>ralphs_product</code></td><td>选择门店。ID 由 ralphs.com 上门店页面 URL 中的分区编号和门店编号拼接而成： <code>…/stores/grocery/ca/los-osos/los-osos/703/00271</code> → <code>70300271</code>在以下情况时必填 <code>fulfillment_type</code> is <code>pickup</code> 或 <code>in_store</code>.</td><td>-</td></tr><tr><td><code>delivery_zip</code></td><td><code>ralphs_search</code>, <code>ralphs_product</code></td><td>配送区域的 ZIP code，例如 <code>90012</code>在以下情况时必填 <code>fulfillment_type</code> is <code>delivery</code>.</td><td>-</td></tr><tr><td><code>fulfillment_type</code></td><td><code>ralphs_search</code>, <code>ralphs_product</code></td><td>配送方式。可用值： <code>pickup</code>, <code>delivery</code>, <code>in_store</code>. <code>pickup</code> 和 <code>in_store</code> 需要 <code>store_id</code>; <code>delivery</code> 需要 <code>delivery_zip</code>.</td><td><code>in_store</code> 与 <code>store_id</code> 单独， <code>delivery</code> 与 <code>delivery_zip</code> 单独</td></tr><tr><td><code>price_range</code></td><td><code>ralphs_search</code></td><td>价格筛选器，格式为 <code>min_price-max_price</code> ，保留两位小数，例如 <code>2.00-5.00</code>.</td><td>-</td></tr><tr><td><code>brand</code></td><td><code>ralphs_search</code></td><td>将结果筛选为某个品牌，例如 <code>Fairlife</code>.</td><td>-</td></tr></tbody></table>

如果 `fulfillment_type` 在未设置其所需参数的情况下设置，则结果会返回 `status_code` 400。一个 `store_id` Ralphs 之外的门店，或一个 `delivery_zip` 超出其配送区域的，会返回 `status_code` 613.

```json
{
    "source": "ralphs_search",
    "query": "milk",
    "store_id": "70300271",
    "fulfillment_type": "pickup",
    "brand": "Fairlife"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/cn/web-scraper-api/mu-biao/dian-zi-shang-wu/ralphs.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
